//
// ԊORJ[
// 2000/08/22 Version 0.1 Copyright(C) T.Sagae 2000
// 2000/08/24 RecIrData() ̃p[^ύXĔ₷
// 2000/08/30 ~ł悤ɋ@\ǉ
//
// EEPROM gp
// ir data 5byte * 12 = 60 byte
//

#include	<16F84.h>

int status @ 0x03;
int porta  @ 0x05;
int portb  @ 0x06;
int eedata @ 0x08;
int eeadr  @ 0x09;
int intcon @ 0x0B;
int option @ 0x81;
int trisa  @ 0x85;
int trisb  @ 0x86;
int eecon1 @ 0x88;
int eecon2 @ 0x89;

#include	<ir.h>

#undef	IR_SEND
#define	IR_SEND	3	// ԊOM|[g
#undef	IR_REC
#define	IR_REC	4	// ԊOM|[g

#define	KEY_A	4	// L[XCb``
#define	KEY_B	5	// L[XCb`a

int	DataAdr;		// EEPROM擪AhXw
int	KeyStatus;		// L[XCb`̏
unsigned	int	PWMratio;		// [^[̂ovl䗦
unsigned	int	PWMcount;
unsigned	int	AutoOffCount0;	// [^[~JEgp
unsigned	int	AutoOffCount1;
unsigned	int	AutoOffCount2;
unsigned	int	SystemMode;

// O[oϐ̒`͂܂łɍs

#include	<ir.c>
#include	<pause.c>

void	WriteEEPROM()
{
	eecon1 |= 0x04;
	eecon2 |= 0x55;
	eecon2 |= 0xaa;
	eecon1 |= 0x02;
	asm(
WriteEEPROM000
	btfsc	eecon1,1
	goto	WriteEEPROM000
	);
	eecon1 &= ~0x04;
}

void	IrSave()
{
	int		n;

	for( n=0; n<5; n++ ) {
		eeadr = DataAdr+n;
		eedata = IrCode[n];
		WriteEEPROM();
	}
}

void	ir_rec()
{
	unsigned int num;
	unsigned int adr;
	unsigned int m;

//	if( RecIrData(0x3,2) != 0 ) {
	m = RecIrData(0x3,1);
	asm(
	movf	m,1
	btfsc	status,2
	goto	ir_rec00
	);
		return;
//	}
ir_rec00:
// Mf[^̌
	adr = 0;
	for( num=1; num<13; num++ ) {
		for( m=0; m<5; m++ ) {
			eeadr = adr+m;
			eecon1 |= 0x01;
			if( eedata != IrCode[m] ) {
				break;
			}
		}
		adr += 5;
		if( m == 5 ) {
			// vĂ
			// ~pJE^̏
			AutoOffCount0 = 0;
			AutoOffCount1 = 0;
			AutoOffCount2 = 0;
			RecIrDataInit();
			// num ɏ]ă[^[𓮂
			// USĂ̏o͂Itɂ
			portb = 0;
			// 0:^COiA1:^C
			// 2:E^COiA3:E^C
			switch( num ) {
			case	1:	// O
				portb = 0x04;
				break;
			case	2:	// Oi
				portb = 0x05;
				break;
			case	3:	// OE
				portb = 0x01;
				break;
			case	4:	// ]
				portb = 0x06;
				break;
			case	5:	// ~
				break;
			case	6:	// E]
				portb = 0x09;
				break;
			case	7:	// ㍶
				portb = 0x08;
				break;
			case	8:	// 
				portb = 0x0a;
				break;
			case	9:	// E
				portb = 0x02;
				break;
			case	10:	// 
				break;
			case	11:	// 
				break;
			case	12:	// 
				break;
			}
			// MM̔ԍ LED \
			porta = num;
			return;
		}
	}
	// vf[^
	RecIrDataInit();
}

// L[̂҂
void	key_release()
{
key_release_top:
	asm(
	btfss	portb,KEY_A
	goto	key_release_top
	btfss	portb,KEY_B
	goto	key_release_top
	);
	pause_ms(5);
	asm(
	btfss	portb,KEY_A
	goto	key_release_top
	btfss	portb,KEY_B
	goto	key_release_top
	);
}

// KeyStatus = 0x00 ĂȂ
// KeyStatus = 0x01 `ꂽ
// KeyStatus = 0x02 `ꂽ
// KeyStatus = 0x04 aꂽ
// KeyStatus = 0x08 aꂽ
void	key_in()
{
	unsigned int key;
	unsigned int n;

	KeyStatus = 0;
	asm(
	btfss	portb,KEY_A
	goto	key_in00
	btfss	portb,KEY_B
	goto	key_in00
	);
	return;
key_in00:
	// `^O
	pause_ms(10);
	asm(
	btfss	portb,KEY_A
	goto	key_in01
	btfss	portb,KEY_B
	goto	key_in01
	);
	return;
key_in01:
	// L[Ă
	key = portb;
	// Ă邩肷
	n = 0;
key_in10:
		asm(
		btfss	portb,KEY_A
		goto	key_in11
		btfss	portb,KEY_B
		goto	key_in11
		// ꂽ
		btfss	key,KEY_A
		bsf		KeyStatus,0
		btfss	key,KEY_B
		bsf		KeyStatus,2
		);
		return;
key_in11:
		// sublw 30 ̏ꍇ 30~pause_ms(50) = 1.5bȏ㉟ƒƔ
		asm(
		movf	n,0
		sublw	30
		btfss	status,2
		goto	key_in12
		);
		// ꂽƂm点
		porta = ~porta;
		pause_ms(250);
		porta = ~porta;
		pause_ms(250);
		porta = ~porta;
		pause_ms(250);
		porta = ~porta;
		asm(
		btfss	key,KEY_A
		bsf		KeyStatus,1
		btfss	key,KEY_B
		bsf		KeyStatus,3
		);
		return;
key_in12:
		pause_ms(50);
	asm(
	incf	n,1
	goto	key_in10
	);
}

void	key_scan()
{
	unsigned	int	led;
	unsigned	int	n;

	key_in();
	asm(
	movf	KeyStatus,1
	btfss	status,2
	goto	key_scan00
	);
	return;
key_scan00:
	// L[Ă
	// KEY_B ꂽꍇwK[hɓ
	asm(
	btfsc	KeyStatus,3
	goto	key_scan02
	);
	return;
key_scan02:
	// [^[~違LED
	asm(
	bcf		portb,0
	bcf		portb,1
	bcf		portb,2
	bcf		portb,3
	);
	led = 1;		// 1ԂIĂԂɂ
	porta = led;
	key_release();	// L[̂҂

key_scan10:
	key_in();
	asm(
	movf	KeyStatus,1
	btfsc	status,2
	goto	key_scan10
	);
	key_release();	// L[̂҂
	asm(
	btfsc	KeyStatus,0
	goto	key_scan11
	btfsc	KeyStatus,1
	goto	key_scan12
	btfsc	KeyStatus,2
	goto	key_scan13
	btfsc	KeyStatus,3
	goto	key_scan14
	goto	key_scan10
	);

key_scan11:
	// key A ꂽԍ̃Abv
	led++;
	asm(
	movf	led,0
	sublw	14
	btfss	status,2
	goto	key_scan11A
	);
	led = 1;
key_scan11A:
	porta = led;
	goto	key_scan10;

key_scan12:
	// key A ꂽeo^[h
	if( led == 13 ) {
		// led = 13 ŒꂽI[gXgbṽ[h]
		asm(
		incf	SystemMode,1
		);
		eeadr = 63;
		eedata = SystemMode;
		WriteEEPROM();
		goto	key_scan12B;
	}
key_scan12A:
	// mFpLED\
	porta = 0xf;
	n = RecIrData(0,1);
	porta = led;
	asm(
	movf	n,1
	btfsc	status,2
	goto	key_scan12C
	);
		RecIrDataInit();
		goto	key_scan10;
key_scan12C:
//	DataAdr = (led-1)*5;	// * gƃ[ĤŎgȂ
	DataAdr = led-1;
	asm(
	movf	DataAdr,0
	addwf	DataAdr,1
	addwf	DataAdr,1
	addwf	DataAdr,1
	addwf	DataAdr,1
	);
	IrSave();
	RecIrDataInit();
key_scan12B:
	// mFpLED\
	porta = 0x5;
	pause_ms(250);
	porta = 0xa;
	pause_ms(250);
	porta = led;
	goto	key_scan10;

key_scan13:
key_scan14:
	// key B ꂽo^[h̉
	// key B ꂽo^[h̉
	porta = 0;	// LED
	return;
}

void	speed_scan()	// x䑼
{
	asm(
	btfsc	SystemMode,0
	goto	speed_scan0
	);
	// ~pJE^̍XV
	asm(
	incf	AutoOffCount0,1
	btfsc	status,2
	incf	AutoOffCount1,1
	btfsc	status,2
	incf	AutoOffCount2,1
	);
	// 莞Ԏw~
	// AutoOffCount2bit3`FbNƖ9b
	asm(
	btfss	AutoOffCount2,3
	goto	speed_scan0
	);
	porta = 0;
	portb = 0;
speed_scan0:
	return;
	// ovl䂵đxs
/*
	PWMcount++;
	if( PWMcount == PWMratio ) {
		
		
		
	}
*/
	
	
}

void	main()
{
	trisa = 0xf0;	// 11110000 bit0-3:output
	trisb = 0xf0;	// 00110000 bit6-7:output,bit4-5:input,bit0-3:output
	porta = 0;
	portb = 0;
	option &= ~0x80;		// portb pullup

	PWMratio = 0xff;		// [^[̂ovl䗦
	PWMcount = 0;			// [^[̂ovl䗦
	AutoOffCount0 = 0;		// [^[~JEgp
	AutoOffCount1 = 0;
	AutoOffCount2 = 0;

	eeadr = 63;
	eecon1 |= 0x01;
	SystemMode = eedata;

	RecIrDataInit();
	while( 1 ) {
		speed_scan();	// x䑼
mainSkip00:
		asm(
		// IRMmF
		btfsc	IR_RPORT,IR_REC
		goto	mainSkip01
		);
		ir_rec();		// RM̎M
mainSkip01:
		key_scan();		// L[XCb`̓͊Ď
	}
}
